stages:
  - pure
<% IMAGE_PURPOSE.each do |image_purpose| -%>
  - <%= image_purpose %>
<% end -%>  

variables:
  # DOCKER_HOST: tcp://docker:2375/
  DOCKER_DRIVER: overlay2
  DOCKER_TLS_CERTDIR: ""

.ruby:
  image: ${CI_DEPENDENCY_PROXY_GROUP_IMAGE_PREFIX}/docker:dind
  services:
    - name: ${CI_DEPENDENCY_PROXY_GROUP_IMAGE_PREFIX}/docker:dind
      alias: docker
  before_script:
    - echo $CI_JOB_TOKEN | docker login -u gitlab-ci-token --password-stdin $CI_REGISTRY

<% RUBY_VERSIONS.each do |ruby_version| -%>
<% RUBY_PRESETS.each_with_index do |preset, index| -%>
# ===========================
<% clean_preset = preset.reject { |k, v| k == :purpose } -%>
<% purpose_name = preset[:purpose] || "pure" -%>
<% prev_purpose = ((index = IMAGE_PURPOSE.index(purpose_name)) || 0) > 0 ? IMAGE_PURPOSE[index - 1] : nil -%>
<% ruby_name = clean_preset.empty? ? nil : clean_preset.keys.join('-') -%>
<% ruby_version_name = ruby_name ? "#{ruby_name}-#{ruby_version}" : ruby_version -%>
<% stage_name = "#{purpose_name}-#{ruby_version_name}" -%>
<% BASE_IMAGES.each do |base_image| -%>
<% image_tag = ruby_name ? "#{ruby_version}-#{ruby_name}-#{base_image}" : "#{ruby_version}-#{base_image}" -%>
# <%= stage_name %>: <%= clean_preset %>

ruby-<%= base_image %>-<%= stage_name %>:
  stage: <%= purpose_name %>
  extends: .ruby
<% if prev_purpose -%>
  needs:
    - <%= "ruby-#{base_image}-#{prev_purpose}-#{ruby_version_name}" %>
<% end -%>
  variables:
    RUBY_IMAGE: $CI_REGISTRY_IMAGE/<%= purpose_name %>:<%= image_tag %>
  script:
    - docker pull $RUBY_IMAGE || true
    - docker build -f Dockerfile.ruby.<%= base_image %>
                   --cache-from $RUBY_IMAGE
                   --build-arg purpose=<%= purpose_name %>
                   --build-arg BASE_IMAGE=ruby:<%= ruby_version %>-<%= base_image %> <%= clean_preset.empty? ? nil : clean_preset.map { |k, v| "--build-arg #{k}=#{v}" }.join(" ") -%>
                   -t $RUBY_IMAGE .
    - docker push $RUBY_IMAGE
<% end -%>
<% end -%>
<% end -%>
